<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card max-width="90%">
            <v-card-title >
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false" class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.name}}</td>
                            <td>{{ item.commission_amount}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout>
                            <v-flex>
                                <v-text-field @change="setName" v-model="selectedItem.name" label="اسم"></v-text-field>
                            </v-flex>
                            <v-flex>
                                <v-text-field @change="setCommissionAmount" v-model="selectedItem.commission_amount" label="کمیسیون"></v-text-field>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این بار را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="AlertDialog"
                max-width="500"
        >

            <v-card>
                <v-card-text>
                    {{alertDialogMessage}}
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAlertDialog">باشه</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "cargoType",
        methods: {
            ...mapMutations({
                setName:'cargoType/setName',
                setCommissionAmount:'cargoType/setCommissionAmount',
                hideAlertDialog: 'cargoType/hideAlertDialog',
                setSelectedItem: 'cargoType/setSelectedItem',
                showAddDialog:'cargoType/showAddDialog',
                hideAddDialog: 'cargoType/hideAddDialog',
                showDeleteDialog:'cargoType/showDeleteDialog',
                hideDeleteDialog:'cargoType/hideDeleteDialog'
            }),
            ...mapActions({
                readData: 'cargoType/readData',
                addOrEdit: 'cargoType/addOrEdit',
                deleteOne:'cargoType/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    name: null,
                    commission_amount: null,
                });
                this.showAddDialog();
            },
            edit(item){
                this.setSelectedItem({
                    id: item.id,
                    name: item.name,
                    commission_amount: item.commission_amount,
                });
                this.showAddDialog();
            },
            add_Edit(){
                this.addOrEdit();
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
        },
        computed: {
            ...mapState({
                allData: state => state.cargoType.allData,
                AddDialog: state => state.cargoType.AddDialog,
                DeleteDialog: state => state.cargoType.DeleteDialog,
                selectedItem: state => state.cargoType.selectedItem,
                pending: state => state.cargoType.pending,
                allDataLoading: state => state.cargoType.allDataLoading,
                AlertDialog: state => state.cargoType.AlertDialog,
                alertDialogMessage: state => state.cargoType.alertDialogMessage,
            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                headers: [
                    {text: 'نام', align: 'right', value: 'name'},
                    {text: 'کمیسیون', align: 'right', value: 'commission_amount'},
                ],
            }
        },

    }
</script>
<style scoped>
</style>